// PCPages32.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "PCPages32.h"

#include "MainFrm.h"
#include "PG_CmdLineInfo.h"
#include "PG_SplashWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App

BEGIN_MESSAGE_MAP(CPCPages32App, CWinApp)
	//{{AFX_MSG_MAP(CPCPages32App)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App construction

CPCPages32App::CPCPages32App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_bNoConnect = FALSE;
}

CPCPages32App::~CPCPages32App()
{
	//
	// Delete the directory context
	if ( m_pDS != NULL )
		{
			delete m_pDS;
			m_pDS = NULL;
		}
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPCPages32App object

CPCPages32App theApp;

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App initialization

BOOL CPCPages32App::InitInstance()
{
	if ( !AfxSocketInit() )
		{
			AfxMessageBox( IDP_SOCKETS_INIT_FAILED );
			return FALSE;
		}

	AfxEnableControlContainer();

#ifdef _DEBUG
	extern BOOL afxTraceEnabled;
	afxTraceEnabled = TRUE;
#endif

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey( _T( "Brunel University" ) );

	//
	// Parse the command line and get runtime flags
	PG_CmdLineInfo cmdInfo;
	ParseCommandLine( cmdInfo );

	m_bNoConnect = cmdInfo.m_bNoConnect;
	if ( cmdInfo.m_bShowSplash == TRUE )
		{
			m_splashWnd.Create();
			m_splashWnd.EnableSplashScreen( cmdInfo.m_bShowSplash );
			m_splashWnd.ShowSplashScreen( NULL );
		}

	//
	// Intialise the directory service. Begin by reading bootstrap
	// information from the registry.
	//
	// Create the directory access context
	m_pDS = new QDSManager();
	if ( m_pDS->PreInitialise() == FALSE )
		{
			m_splashWnd.HideSplashScreen();
			ErrorBox( PGS_DSINIT_FAILED );
			return FALSE;
		}

	if ( m_Config.Load() == FALSE )
		{
			m_splashWnd.HideSplashScreen();
			return FALSE;
		}

	if ( LoadBootstrap() == TRUE )
		{
			//
			// Connect to the directory and read boot
			if ( m_bNoConnect == FALSE )
				{
					if ( m_pDS->Initialise( m_sConfDN, m_sHost, m_nPort ) == FALSE )
						{
							delete m_pDS;
							m_pDS = NULL;

							m_splashWnd.HideSplashScreen();
							ErrorBox( PGS_DSINIT_FAILED );

							return FALSE;
						}
				}
		}
	else
		{
			m_splashWnd.HideSplashScreen();
			ErrorBox( PGS_REGINIT_FAILED );
			return FALSE;
		}

	//
	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.
	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	//
	// create and load the frame with its resources
	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);

	//
	// The one and only window has been initialized, so show and update it.
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	//
	// Create the search forms
	pFrame->CreateTabPages();

	//
	// All ready...
	m_splashWnd.HideSplashScreen();
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////
// CPCPages32App::OpenAppKey
// Open a registry key owned by HKCU/Software/Brunel University/PC-Pages.
HKEY CPCPages32App::OpenAppKey( char *pGetKeyName )
{
	if ( pGetKeyName == NULL )
		return NULL;

	//
	// Traverse registry to get to PC-Pages application key
	char *pNameArr[] = 
		{ "Software", "Brunel University", "PC-Pages", "", NULL } ;
	
	HKEY hParentKey = HKEY_CURRENT_USER, hChildKey = NULL;
	for ( int i = 0; pNameArr[i] != NULL; i++ )
		{
			char *pKeyName;
			if ( *pNameArr[i] != '\0' )
				pKeyName = pNameArr[i];
			else
				pKeyName = pGetKeyName;

			LONG ok = RegOpenKeyEx
				( hParentKey,  // handle to open key
					pKeyName,					// address of name of subkey to open
					0,				// reserved
					KEY_READ, // security access mask
					&hChildKey  // address of handle to open key
				);

			if ( hParentKey != HKEY_CURRENT_USER )
				RegCloseKey( hParentKey );

			if ( ok != ERROR_SUCCESS )
				{
#ifdef _DEBUG
					TRACE( "Failed to open requested registry key: %s\n", pGetKeyName );
#endif
					return NULL;
				}
			else
				{
					hParentKey = hChildKey;
				}
		}

	return hParentKey;
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::QueryValue
// Read a registry value.
BOOL CPCPages32App::QueryValue
	( HKEY hKey, char *pValueName, DWORD dwWantType, BYTE *pBuf, DWORD *pBufLen )
{
	DWORD dwGotType;
	LONG lOK = RegQueryValueEx
		(
			hKey,            // handle to key to query
			pValueName,  // address of name of value to query
			NULL,   // reserved
			&dwGotType, // address of buffer for value type
			pBuf,      // address of data buffer
			pBufLen		// address of data buffer size
		);

	if ( lOK != ERROR_SUCCESS )
		{
#ifdef _DEBUG
			TRACE
				( "Failed to read registry value:\n\
					 HKCU/Software/Brunel University/PC-Pages/.../%s\n",
					pValueName );
#endif

			return FALSE;
		}

	if ( dwWantType != dwGotType )
		{
#ifdef _DEBUG
			TRACE
				( "Registry value was of unexpected type (wanted %s, got %d):\n\
					 HKCU/Software/Brunel University/PC-Pages/.../%s\n",
					dwWantType,
					dwGotType,
					pValueName );
#endif

			return FALSE;
		}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Load bootstrap information from the registry. This is:
//
// 1. Configuration root DN.
// 2. LDAP server hosting the configuration...
// 3. and the server's port number.
//
BOOL CPCPages32App::LoadBootstrap()
{
	HKEY hParentKey = OpenAppKey( "Startup" );
	if ( hParentKey == NULL )
		{
#ifdef _DEBUG
			TRACE0( "Failed to read registry key:\nHKCU/Software/Brunel University/PC-Pages/Startup/\n" );
#endif
			return FALSE;
		}

	//
	// Get key/value information
	DWORD dwNumValues;
	DWORD dwMaxValueLen;
	DWORD dwMaxValueNameLen;
	
	LONG ok = RegQueryInfoKey
		(
			hParentKey,                // handle to key to query
			NULL,           // address of buffer for class string
			NULL,        // address of size of class string buffer
			NULL,       // reserved
			NULL,       // address of buffer for number of subkeys
			NULL,  // address of buffer for longest subkey name length
			NULL,  // address of buffer for longest class string length
			&dwNumValues,        // address of buffer for number of value entries
			&dwMaxValueNameLen,  // address of buffer for longest value name length
			&dwMaxValueLen,  // address of buffer for longest value data length
			NULL,           // address of buffer for security descriptor length
			NULL						// address of buffer for last write time
		);

	if ( ok != ERROR_SUCCESS )
		{
			RegCloseKey( hParentKey );
			return FALSE;
		}
 
	//
	// Get the confuguration root DN
#define KEYVAL_BUFLEN 4096
	DWORD dwValueType;
	BYTE dataBuf[KEYVAL_BUFLEN];
	DWORD dwDataBufLen = KEYVAL_BUFLEN;
	ok = RegQueryValueEx
		(
			hParentKey,            // handle to key to query
			"Configuration Subtree DN",  // address of name of value to query
			NULL,   // reserved
			&dwValueType, // address of buffer for value type
			dataBuf,      // address of data buffer
			&dwDataBufLen		// address of data buffer size
		);

	if ( ok != ERROR_SUCCESS )
		{
#ifdef _DEBUG
			TRACE0
				( "Failed to read registry key:\nHKCU/Software/Brunel University/PC-Pages/Startup/Configuration DN\n" );
#endif

			return FALSE;
			RegCloseKey( hParentKey );
		}

	m_sConfDN = ( char * ) dataBuf;

	//
	// Get the server's IP address
	ok = RegQueryValueEx
		(
			hParentKey,            // handle to key to query
			"Server Address",  // address of name of value to query
			NULL,   // reserved
			&dwValueType, // address of buffer for value type
			dataBuf,      // address of data buffer
			&dwDataBufLen		// address of data buffer size
		);

	if ( ok != ERROR_SUCCESS )
		{
#ifdef _DEBUG
			TRACE0
				( "Failed to read registry key:\nHKCU/Software/Brunel University/PC-Pages/Startup/Server Address\n" );
#endif

			return FALSE;
			RegCloseKey( hParentKey );
		}

	m_sHost = ( char * ) dataBuf;

	// 
	// Get the server's port number
	ok = RegQueryValueEx
		(
			hParentKey,            // handle to key to query
			"Server Port",  // address of name of value to query
			NULL,   // reserved
			&dwValueType, // address of buffer for value type
			dataBuf,      // address of data buffer
			&dwDataBufLen		// address of data buffer size
		);

	if ( ok != ERROR_SUCCESS )
		{
#ifdef _DEBUG
			TRACE0
				( "Failed to read registry key:\nHKCU/Software/Brunel University/PC-Pages/Startup/Server Port\n" );
#endif

			return FALSE;
			RegCloseKey( hParentKey );
		}

	m_nPort = static_cast<int> ( *( reinterpret_cast<DWORD *>( dataBuf ) ) );

	//
	// All done!
	RegCloseKey( hParentKey );
	return TRUE;
} 

/////////////////////////////////////////////////////////////////////////////
// Error message dialog box
void CPCPages32App::ErrorBox( UINT msgId )
{
	CString msg, title;
	msg.LoadString( msgId );
	title.LoadString( PGS_MSGERR_TITLE );

	m_splashWnd.HideSplashScreen();
	MessageBox( NULL, msg, title, MB_ICONERROR );
}

/////////////////////////////////////////////////////////////////////////////
// Error message dialog box
void CPCPages32App::ShowDITDisplay()
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->m_pLhsTabCtrl->ShowDITCtrl();
}

void CPCPages32App::ShowEntryListDisplay()
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->m_pRhsTabCtrl->ShowEntryListDisplay();
}

void CPCPages32App::ShowEntryListContainer()
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->m_pRhsTabCtrl->ShowEntryListContainer();
}

void CPCPages32App::ShowEntryView()
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->m_pRhsTabCtrl->ShowEntryView();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CPCPages32App::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

int CPCPages32App::ExitInstance() 
{
	int nRetVal = CWinApp::ExitInstance();
	return nRetVal;
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::OnIdle
//
// The idle handler is used to poll the directory when a request
// is in progress.
BOOL CPCPages32App::OnIdle( LONG lCount ) 
{
	m_pDS->TidyUp();
  if ( m_pDS->Waiting() )
    {
			WaitMode( TRUE );
      m_pDS->Poll();
      return m_pDS->Waiting();
    }
  else
		{
			WaitMode( FALSE );

			//
			// Notify of any errors
			if ( m_errList.GetCount() > 0 )
				{
				}

			return FALSE;
		}
	
	// return CWinApp::OnIdle( lCount );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::WaitMode
// Put PC-Pages in wait mode.
void CPCPages32App::WaitMode( BOOL bOn )
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->WaitMode( bOn );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::SetMessageText
// Set the status bar string.
void CPCPages32App::SetMessageText( LPCTSTR pStr, BOOL bFlash )
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->SetMessageText( pStr );

	if ( bFlash == TRUE )
		pFrame->FlashMessageText();
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::SetMessageText
// Set the status bar string.
void CPCPages32App::SetMessageText( UINT nResID, BOOL bFlash )
{
	CString str;
	str.LoadString( nResID );
	SetMessageText( str, bFlash );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::FlashMessageText
// Flash the status bar .
void CPCPages32App::FlashMessageText()
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	pFrame->FlashMessageText();
}


/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::WaitDialog
// Return a pointer to the wait dialog.
PG_WaitDialog *CPCPages32App::WaitDialog()
{
	CMainFrame *pFrame = static_cast<CMainFrame *>( m_pMainWnd );
	return pFrame->WaitDialog();
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::MainFrame
// Return a pointer to the main frame.
CMainFrame *CPCPages32App::MainFrame()
{
	return static_cast<CMainFrame *>( m_pMainWnd );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::MainFrame
// Return a pointer to the main frame.
void CPCPages32App::Flash( CWnd *pParentWnd, CRect &rFromRect, CRect &rToRect )
{
	m_flashWnd.Flash( pParentWnd, rFromRect, rToRect );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::AddError()
void CPCPages32App::AddError( QError *pErr )
{
	//
	// Add the error to the list
	m_errList.AddTail( pErr );

	//
	// Enable the status bar error indicator
	MainFrame()->StatusBar().EnablePane( 1, TRUE );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::ClearErrors()
void CPCPages32App::ClearErrors()
{
	//
	// Remove all errors
	POSITION pos = m_errList.GetHeadPosition();
	while ( pos != NULL )
		{
			QError *pErr = m_errList.GetNext( pos );
			delete pErr;
		}

	m_errList.RemoveAll();

	//
	// Disable the status bar error indicator
	MainFrame()->StatusBar().EnablePane( 1, FALSE );
}

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App::ShowErrors()
void CPCPages32App::ShowErrors()
{
	AfxMessageBox( "Errors here XXX!!!!", MB_OK );
}
