// PG_DITCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_DITCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PG_DITCtrl

PG_DITCtrl::PG_DITCtrl()
{
}

PG_DITCtrl::~PG_DITCtrl()
{
}

/////////////////////////////////////////////////////////////////////////////
// PG_DITCtrl::AddEntry
BOOL PG_DITCtrl::AddEntry( QEntry *pEntry, BOOL bShow )
{
	PG_DITCtrlEntry *pCurrEntry = m_pRootEntry;

	//
	// Get the entry's RDN list in most significant order (reverse of
	// the current order)
	PtrList<QRDN> rdnList;
	POSITION pos = pEntry->DN().GetHeadRDNPosition();
	while ( pos != NULL )
		{
			rdnList.AddHead( pEntry->DN().GetNextRDN( pos ) );
		}

	pos = rdnList.GetHeadPosition();
	while ( pos != NULL )
		{
			QRDN *pRDN = rdnList.GetNext( pos );
			PG_DITCtrlEntry *pChild;
			
			if ( pCurrEntry->GetChild( *pRDN, &pChild ) == FALSE )
				{
					pCurrEntry->AddChild( pEntry, pRDN, bShow );
					return TRUE;
				}
			else
				{
					pCurrEntry = pChild;
				}
		}

	//
	// The entry is already in the tree
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// PG_DITCtrl::RemoveEntry XXX Unimplemented
BOOL PG_DITCtrl::RemoveEntry( QEntry *pEntry )
{
	return FALSE;
}

BEGIN_MESSAGE_MAP(PG_DITCtrl, CTreeCtrl)
	//{{AFX_MSG_MAP(PG_DITCtrl)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PG_DITCtrl message handlers

BOOL PG_DITCtrl::Create( RECT &rect, CWnd *pParent, UINT nId )
{
  //
  // Create root entry
  m_pRootEntry = new PG_DITCtrlEntry( this );

  //
  // Create tree control
  BOOL bOK = CTreeCtrl::Create
		( WS_VISIBLE|TVS_LINESATROOT|TVS_HASLINES|TVS_EDITLABELS|TVS_HASBUTTONS|WS_BORDER,
			rect,
			pParent,
			nId );

	m_imageList.Create( IDB_ENTRY_ICONS, 19, 0, RGB( 0xff, 0xff, 0xff ) );
  SetImageList( &m_imageList, TVSIL_NORMAL );

  ModifyStyleEx( 0, WS_EX_CLIENTEDGE );
  return bOK;
}

void PG_DITCtrl::OnDestroy() 
{
	if ( m_pRootEntry != NULL )
		{
			delete m_pRootEntry;
			m_pRootEntry = NULL;
		}

	CTreeCtrl::OnDestroy();
}
