#if !defined(AFX_PG_ENTRYLISTCTRL_H__E89FFE20_407F_11D3_89E9_FA7E743FBD3E__INCLUDED_)
#define AFX_PG_ENTRYLISTCTRL_H__E89FFE20_407F_11D3_89E9_FA7E743FBD3E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PG_EntryListCtrl.h : header file
//

#include "QReadEntry.h"
#include "PG_EntryListInfo.h"
#include "PG_DisplayEntryHandler.h"

/////////////////////////////////////////////////////////////////////////////
// PG_EntryListCtrl window

class PG_EntryListCtrl : public CListCtrl
{
// Construction
public:
	PG_EntryListCtrl();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PG_EntryListCtrl)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~PG_EntryListCtrl();

public:
	// Create and initialise the window
	void Create( CWnd *pParentWnd, RECT &rect, UINT nId );

	// Add entries to the list
	void AddEntry( QEntry *pEntry );
	void AddEntryList( PtrList<QEntry> &entryList );

	// Clear entries from the list
	void RemoveEntry( QDN &dn );
	void RemoveAllEntries();

	// Set the context menu
	void SetContextMenuResID( int nResID );

	// Access multiple selection option.
	// Set option BEFORE calling Create.
	BOOL &AllowMultiSel() { return m_bMultiSel; } ;

private:
	void DisplayEntry( int nItemID );

private:
	//
	// Entry icons
  CImageList m_imageList;

	//
	// Column configuration
	PG_EntryListConfig m_elConfig;

	//
	// Read request invocation class
	QReadEntry *m_pEntryReader;

	//
	// Request handler for displaying entries
	PG_DisplayEntryHandler m_readHandler;

private:
	//
	// The list of entries in and a count of them
	PtrList<QEntry> m_entryList;
	UINT m_entryCount;

	//
	// Context menu resource ID
	int m_nMenuID;

	// 
	// Whethere multiple selection is permitted
	BOOL m_bMultiSel;
	
	// Generated message map functions
protected:
	//{{AFX_MSG(PG_EntryListCtrl)
	afx_msg void OnDestroy();
	afx_msg void OnItemdblclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnCollectEntry();
	afx_msg void OnMailTo();
	afx_msg void OnViewEntry();
	afx_msg void OnRemoveEntry();
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PG_ENTRYLISTCTRL_H__E89FFE20_407F_11D3_89E9_FA7E743FBD3E__INCLUDED_)
