// PG_EntryListInfo.h: interface for the PG_EntryListInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PG_ENTRYLISTINFO_H__70F47941_44D1_11D3_89E9_8FCDDE190E78__INCLUDED_)
#define AFX_PG_ENTRYLISTINFO_H__70F47941_44D1_11D3_89E9_8FCDDE190E78__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "oidtable.h"

class PG_ColAttrTSpec
{
public:
	PG_ColAttrTSpec( QAttrT *pAttrT, BOOL bPrefRDN );
	virtual ~PG_ColAttrTSpec();

public:
	BOOL GetEntryValue( QEntry *pEntry, CString &rStrVal );

private:
	QAttrT *m_pAttrT;
	BOOL m_bPrefRDN;
};

template PtrList<PG_ColAttrTSpec>;

class PG_ColumnSpec
{
public:
	PG_ColumnSpec();
	virtual ~PG_ColumnSpec();

public:
	BOOL SetColumnSpec( QOC *pOC, UINT nIconID, QStringList &rColATSpecList );
  BOOL GetValue( QEntry *pEntry, UINT nColID, CString &strVal );

	BOOL HasOC( QOC *pOC )
		{ return pOC == m_pOC ; } ;

	UINT GetIconID()
		{ return m_nIconID ; } ;

private:
	QOC *m_pOC;
	UINT m_nIconID;
	PtrList<PG_ColAttrTSpec> m_CATSpecList;
};

template PtrList<PG_ColumnSpec>;

class PG_EntryListConfig
{
public:
	PG_EntryListConfig();
	virtual ~PG_EntryListConfig();

public:
	BOOL ReadConfiguration();
	UINT GetColumnList( QStringList &rColList )
		{
			rColList = m_colNameList;
			return rColList.GetCount();
		};

public:
	//
	// Get the attribute type specification for the
	// given object class and at the identified column
	BOOL GetColumnValue( QEntry *pEntry, UINT nColID, CString &rStrVal );

	//
	// Get the icon ID associated with the given object class
	BOOL GetIconID( QEntry *pEntry, UINT &nIconID );

private:
	//
	// Retrieve just one value of a given attribute type from an entry
	BOOL GetEntryValue( QEntry *pEntry, QAttrT *pAttrT, CString &rStrVal );

private:
	QStringList m_colNameList;
	PtrList<PG_ColAttrTSpec> m_colATList;
};

#endif // !defined(AFX_PG_ENTRYLISTINFO_H__70F47941_44D1_11D3_89E9_8FCDDE190E78__INCLUDED_)
