// PG_LHSTabCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_LHSTabCtrl.h"
#include "PG_FormWin.h"
#include "QFormConfiguration.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PG_LHSTabCtrl

PG_LHSTabCtrl::PG_LHSTabCtrl()
{
}

PG_LHSTabCtrl::~PG_LHSTabCtrl()
{
}

BEGIN_MESSAGE_MAP(PG_LHSTabCtrl, CTabCtrl)
	//{{AFX_MSG_MAP(PG_LHSTabCtrl)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PG_LHSTabCtrl message handlers

int PG_LHSTabCtrl::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if ( PG_TabCtrlBase::OnCreate( lpCreateStruct ) == -1 )
		return -1;

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Create tab windows for each defined search form
void PG_LHSTabCtrl::CreateTabPages()
{
	extern CPCPages32App theApp;

  //
  // Create default notebook items
	UINT tab_index = 0;
  TC_ITEM list;
  list.mask = TCIF_TEXT;
  list.pszText = "Browser";
  InsertItem( tab_index, &list );

	CRect rect;
	GetClientRect( &rect );

	AdjustRect( FALSE, &rect );
	theApp.DITDisplay().Create( rect, this, tab_index++ );

	//
	// Read and create search forms
	CStringList name_list;

	QFormConfiguration *form_conf = theApp.DS()->FormConfig();
	form_conf->GetFormList( name_list );

	POSITION pos = name_list.GetHeadPosition();
	int form_num = name_list.GetCount();

	while ( pos != NULL )
		{
			//
			// Create tab page and form entry window for
			// each configured search form.
			CString name = name_list.GetNext( pos );
			QForm *form = form_conf->GetForm( name );
			PG_FormWin *form_win = new PG_FormWin( form );

			form_win_list.AddTail( form_win );
			form_win->Create( this, rect, tab_index );

			TC_ITEM form_tab;
		  form_tab.mask = TCIF_TEXT;

			char *tmp_name = new char[ name.GetLength() + 1 ];
			strcpy( tmp_name, name );

			form_tab.pszText = tmp_name;
			InsertItem( tab_index++, &form_tab );

			form_win->ShowWindow( SW_HIDE );
			delete tmp_name;
		}

	//
	// Set initially displayed tab to the browser
	SetCurSel( 0 );
	cur_sel_id = 0;
}

/////////////////////////////////////////////////////////////////////////////
// Display the newly selected tab window
void PG_LHSTabCtrl::OnSelchange( NMHDR* pNMHDR, LRESULT* pResult ) 
{
	int new_sel_id = GetCurSel();
	if ( cur_sel_id != new_sel_id )
		{
			ShowTab( cur_sel_id, SW_HIDE );
			ShowTab( new_sel_id, SW_SHOW );
			cur_sel_id = new_sel_id;
		}
}

/////////////////////////////////////////////////////////////////////////////
// Get the window corresponding to the given tab identifier
CWnd *PG_LHSTabCtrl::GetTabWindow( int tab_id )
{
	extern CPCPages32App theApp;

	if ( tab_id < 0 )
		return NULL;

	if ( tab_id == 0 )
		//
		// Browser tab ( XXX browser tab window unimplemented as yet)
		{
			return static_cast<CWnd *>( &theApp.DITDisplay() );
		}
	else
		//
		// One of the form tabs
		{
			return form_win_list.GetAt
				( form_win_list.FindIndex( tab_id - 1 ) );
		}
}

/////////////////////////////////////////////////////////////////////////////
// Show the selected tab window
void PG_LHSTabCtrl::SelectTab( int tab_id, BOOL flash )
{
	cur_sel_id = GetCurSel();
	if ( TRUE || cur_sel_id != tab_id )
		{
			ShowTab( cur_sel_id, SW_HIDE );
			ShowTab( tab_id, SW_SHOW, flash );
			SetCurSel( tab_id );
			cur_sel_id = tab_id;
		}
}

/////////////////////////////////////////////////////////////////////////////
// Show or hide the selected tab window
void PG_LHSTabCtrl::ShowTab( int tab_id, int show_cmd, BOOL flash )
{
	extern CPCPages32App theApp;
	CWnd *pWnd;

	if ( tab_id == 0 )
		//
		// Browser tab 
		{
			pWnd = static_cast<CWnd *>( &theApp.DITDisplay() );
		}
	else
		{
			//
			// One of the form tabs
			pWnd = form_win_list.GetAt( form_win_list.FindIndex( tab_id - 1 ) );
		}

	//
	// Show the selected window
	pWnd->ShowWindow( show_cmd );
	if ( show_cmd == SW_SHOW )
		{
			RECT rect;
			GetClientRect( &rect );

			AdjustRect( FALSE, &rect );
			pWnd->SetWindowPos
				( NULL, rect.left, rect.top, (rect.right - rect.left), (rect.bottom - rect.top), SWP_NOZORDER );

			pWnd->UpdateWindow();
		}

	//
	// Flash the client area if requested
	if ( flash == TRUE )
		{
			CRect fromRect, toRect;
			GetItemRect( tab_id, &fromRect );
			GetClientRect( &toRect );

			AdjustRect( FALSE, &toRect );
			theApp.Flash( this, fromRect, toRect );
		}
}

void PG_LHSTabCtrl::ShowDITCtrl()
{
	if ( cur_sel_id != 0 )
		{
			ShowTab( cur_sel_id, SW_HIDE );
			ShowTab( 0, SW_SHOW );
			SetCurSel( 0 );
			cur_sel_id = 0;
		}
}

/////////////////////////////////////////////////////////////////////////////
// Resize the currently display tab window after a resize event
void PG_LHSTabCtrl::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
  RECT rect;
  GetClientRect( &rect );
	AdjustRect( FALSE, &rect );

	CWnd *tab_wnd = GetTabWindow( cur_sel_id );
	if ( tab_wnd != NULL )
		tab_wnd->MoveWindow( &rect );
}

void PG_LHSTabCtrl::OnDestroy() 
{
	extern CPCPages32App theApp;

	//
	// Destroy child windows
	theApp.DITDisplay().DestroyWindow();

	POSITION pos = form_win_list.GetHeadPosition();
	while ( pos != NULL )
		{
			PG_FormWin *pFormWin = form_win_list.GetNext( pos );
			pFormWin->DestroyWindow();
			delete pFormWin;
		}

	PG_TabCtrlBase::OnDestroy();
}
