// PG_RHSTabCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_RHSTabCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PG_RHSTabCtrl

PG_RHSTabCtrl::PG_RHSTabCtrl()
{
  for ( int i = 0; i < 3; i++)
    {
      pTabWndArr[i] = NULL;
    }
}

PG_RHSTabCtrl::~PG_RHSTabCtrl()
{
}

BEGIN_MESSAGE_MAP(PG_RHSTabCtrl, PG_TabCtrlBase)
	//{{AFX_MSG_MAP(PG_RHSTabCtrl)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	ON_NOTIFY_REFLECT(TCN_SELCHANGING, OnSelchanging)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PG_RHSTabCtrl message handlers

int PG_RHSTabCtrl::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if ( PG_TabCtrlBase::OnCreate( lpCreateStruct ) == -1 )
		return -1;

	return 0;
}

void PG_RHSTabCtrl::OnDestroy() 
{
	//
	// Destroy tab pages
  for ( int i = 0; i < 3; i++)
    {
      if ( pTabWndArr[i] != NULL )
				pTabWndArr[i]->DestroyWindow();
    }

	PG_TabCtrlBase::OnDestroy();
}

void PG_RHSTabCtrl::CreateTabPages()
{	
	extern CPCPages32App theApp;

	//
	// Create the entry list tab page and control 
	UINT nId = 0;
  TC_ITEM list, view;
  list.mask = TCIF_TEXT;
	CString str;
	
	str.LoadString( PGS_TAB_ENTRYLIST );
	char *pszText = new char[ str.GetLength() + 1 ];

	strcpy( pszText, str );
  list.pszText = pszText;

  InsertItem( nId, &list );
	delete pszText;

	//
	// Create the window that goes in this tab page
	RECT rect;
	GetClientRect( &rect );
  AdjustRect( FALSE, &rect );

	m_nListID = nId++;
	theApp.EntryListDisplay().AllowMultiSel() = FALSE;
	theApp.EntryListDisplay().Create( this, rect, m_nListID );
	pTabWndArr[m_nListID] = static_cast<CWnd *>( &theApp.EntryListDisplay() );

	//
	// Set tooltip for entry list tab
	RECT tabRect;
	GetItemRect( m_nListID, &tabRect );

	CToolTipCtrl *pToolTips = GetToolTips();
	pToolTips->AddTool( this, PGS_TIP_ENTRYLIST, &tabRect, m_nListID+1 );

	//
	// Set the context menu resource ID
	theApp.EntryListDisplay().SetContextMenuResID
		( IDR_ENTRY_LIST_POPUP_MENU );

	//
	// Create the entry view tab page and control
  view.mask = TCIF_TEXT;

	str.LoadString( PGS_TAB_ENTRYVIEW );
	pszText = new char[ str.GetLength() + 1 ];

	strcpy( pszText, str );
  view.pszText = pszText;

  InsertItem( nId, &view );
	delete pszText;

	//
	// Create the control that goes in this page
	m_nViewID = nId++;
	theApp.EntryView().Create( this, rect, m_nViewID );
	pTabWndArr[m_nViewID] = static_cast<CWnd *>( &theApp.EntryView() );

	//
	// Set tooltip
	GetItemRect( m_nViewID, &tabRect );
	pToolTips->AddTool( this, PGS_TIP_ENTRYVIEW, &tabRect, m_nViewID+1 );

	//
	// Create the collector tab
	str.LoadString( PGS_TAB_COLLECTOR );
	pszText = new char[ str.GetLength() + 1 ];

	strcpy( pszText, str );
  view.pszText = pszText;

  InsertItem( nId, &view );
	delete pszText;

	//
	// Create the control that goes in this page
	m_nCollectorID = nId++;
	theApp.EntryListContainer().AllowMultiSel() = TRUE;
	theApp.EntryListContainer().Create( this, rect, m_nCollectorID );
	pTabWndArr[m_nCollectorID] = static_cast<CWnd *>( &theApp.EntryListContainer() );

	//
	// Set tooltip
	GetItemRect( m_nCollectorID, &tabRect );
	pToolTips->AddTool( this, PGS_TIP_COLLECTOR, &tabRect, m_nCollectorID+1 );

	//
	// Set the context menu resource ID
	theApp.EntryListContainer().SetContextMenuResID
		( IDR_ENTRY_CONTAINER_POPUP_MENU );

	//
	// Show the default window
	pTabWndArr[ m_nListID ]->ShowWindow( SW_SHOW );
	pTabWndArr[ m_nViewID ]->ShowWindow( SW_HIDE );
	pTabWndArr[ m_nCollectorID ]->ShowWindow( SW_HIDE );
}

void PG_RHSTabCtrl::ShowEntryListDisplay()
{
	int nID = GetCurSel();
	if ( nID == m_nListID )
		return;

	ShowTab( nID, SW_HIDE );
	ShowTab( m_nListID, SW_SHOW );
	SetCurSel( m_nListID );
}

void PG_RHSTabCtrl::ShowEntryListContainer()
{
	int nID = GetCurSel();
	if ( nID == m_nCollectorID )
		return;

	ShowTab( nID, SW_HIDE );
	ShowTab( m_nCollectorID, SW_SHOW );
	SetCurSel( m_nCollectorID );
}

void PG_RHSTabCtrl::ShowEntryView()
{
	int nID = GetCurSel();
	if ( nID == m_nViewID )
		return;

	ShowTab( nID, SW_HIDE );
	ShowTab( m_nViewID, SW_SHOW );
	SetCurSel( m_nViewID );
}

/////////////////////////////////////////////////////////////////////////////
// Show or hide the selected tab window
void PG_RHSTabCtrl::ShowTab( int tab_id, int show_cmd )
{
	extern CPCPages32App theApp;
	CWnd *pWnd;

	pWnd = pTabWndArr[ tab_id ];
	RECT rect;

	GetClientRect( &rect );
	AdjustRect( FALSE, &rect );

	SetCurSel( tab_id );
  pWnd->MoveWindow( &rect );
	pWnd->ShowWindow( show_cmd );
}

void PG_RHSTabCtrl::OnSelchange( NMHDR* pNMHDR, LRESULT* pResult ) 
{
  int nId = GetCurSel();
	*pResult = 0;

  if ( pTabWndArr[nId] == NULL )
    return;

  pTabWndArr[nId]->ShowWindow( SW_SHOW );
}

void PG_RHSTabCtrl::OnSelchanging( NMHDR* pNMHDR, LRESULT* pResult ) 
{
  int nId = GetCurSel();
  *pResult = 0;

  if ( pTabWndArr[nId] == NULL )
    return;

  pTabWndArr[nId]->ShowWindow( SW_HIDE );
}

void PG_RHSTabCtrl::OnSize( UINT nType, int cx, int cy ) 
{
	CTabCtrl::OnSize( nType, cx, cy );
	
  RECT rect;
  UINT i;
  GetClientRect( &rect );
  AdjustRect( FALSE, &rect );

  for ( i = 0; i < 3; i++)
    {
      if ( pTabWndArr[i] != NULL )
        pTabWndArr[i]->MoveWindow( &rect );
    }
}

