// PG_WaitDialog.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_WaitDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog dialog

PG_WaitDialog::PG_WaitDialog(CWnd* pParent /*=NULL*/)
	: CDialog(PG_WaitDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(PG_WaitDialog)
	//}}AFX_DATA_INIT
	m_nFrame = IDB_BITMAP1;
	m_bCreated = FALSE;
}


void PG_WaitDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PG_WaitDialog)
	DDX_Control(pDX, IDC_BITMAP, m_staticBitmap);
	DDX_Control(pDX, IDC_NUM_INVOKED, m_staticInvoked);
	DDX_Control(pDX, IDC_NUM_FAILED, m_staticFailed);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PG_WaitDialog, CDialog)
	//{{AFX_MSG_MAP(PG_WaitDialog)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog::OnCreate
//
// Initialisation performed at Window creation time.
int PG_WaitDialog::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_bCreated = TRUE;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog::OnInitDialog
//
// Dialog initialisation. At present this creates the timer event used
// to control the wait animation.
BOOL PG_WaitDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetTimer( 1, 400, NULL );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog::OnTimer
//
// Timer event handler updates the wait animation.
void PG_WaitDialog::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);
	
	if ( ++m_nFrame > IDB_BITMAP8 )
		m_nFrame = IDB_BITMAP1;

	//
	// Load the new bitmap
	HBITMAP hNew =
		( HBITMAP )
				LoadImage
					( AfxGetInstanceHandle(),
						MAKEINTRESOURCE( m_nFrame ),
						IMAGE_BITMAP,
						0, 0,
						LR_LOADTRANSPARENT ) ;

	if ( hNew == NULL )
		//
		// Couldn't load the bitmap!
		return;

	HBITMAP hOld = m_staticBitmap.SetBitmap( hNew );
	DeleteObject( hOld );
}

/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog::OnDestroy
//
// Kill the timer event used for the wait animation.
void PG_WaitDialog::OnDestroy() 
{
	m_bCreated = FALSE;
	CDialog::OnDestroy();
	KillTimer( 1 );
}

/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog::SetOpCounts
//
// Abort the operation in progress in response to user request.
void PG_WaitDialog::OnCancel() 
{
	extern CPCPages32App theApp;
	theApp.DS()->AbortAll();	
	CDialog::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
// PG_WaitDialog::SetOpCounts
//
// Display latest counts of operations performed and failed during this
// request.
void PG_WaitDialog::SetOpCounts( int nInvoked, int nFailed )
{
	if ( m_bCreated == FALSE )
		return;

	CString str;

	str.Format( "%d", nInvoked );
	m_staticInvoked.SetWindowText( str );

	str.Format( "%d", nFailed );
	m_staticFailed.SetWindowText( str );
}