// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "PCPages32.h"

#include "MainFrm.h"
#include "PG_LHSTabWin.h"
#include "PG_RHSTabWin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
// XXX (temporary) Network event notifier
#define PG_CLOSE_EVENT WM_APP+1

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_MESSAGE(PG_CLOSE_EVENT, OnSocketClose)
	ON_BN_CLICKED(ID_FILE_ABORT, OnWaitAbort)
	ON_UPDATE_COMMAND_UI(ID_FILE_ABORT, OnUpdateFileAbort)
	ON_WM_TIMER()
	ON_COMMAND_RANGE(ID_SRCH_BROWSE+1, ID_SRCH_BROWSE+100, OnSrchMenuItem)
	ON_COMMAND(ID_SRCH_BROWSE, OnSrchBrowse)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_ERRS,
	ID_INDICATOR_WORKING
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pLhsTabCtrl = NULL;
	m_pRhsTabCtrl = NULL;
	m_bWait = FALSE;
	m_nWaitFrameIdx = 0;
	m_bSrchMenuEmpty = TRUE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//
	// Set the correct application icon
	extern CPCPages32App theApp;
	SetIcon( theApp.LoadIcon( IDR_MAINFRAME ), TRUE );
	SetIcon( theApp.LoadIcon( IDR_MAINFRAME ), FALSE );

	//
	// Create toolbars
	if (!m_wndToolBar.CreateEx(this) ||
				!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
			TRACE0("Failed to create toolbar\n");
			return -1;      // fail to create
		}

	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME, 
				CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
		{
			TRACE0("Failed to create dialogbar\n");
			return -1;		// fail to create
		}

	if (!m_wndAnimBar.Create(this, IDD_WAIT_ANIM, 
				CBRS_ALIGN_TOP|CBRS_ALIGN_RIGHT, AFX_IDW_DIALOGBAR+1))
		{
			TRACE0("Failed to create dialogbar\n");
			return -1;		// fail to create
		}

	if (!m_wndReBar.Create(this) ||
				!m_wndReBar.AddBar(&m_wndToolBar) ||
				!m_wndReBar.AddBar(&m_wndDlgBar) ||
				!m_wndReBar.AddBar(&m_wndAnimBar, NULL, NULL, RBBS_FIXEDSIZE|RBBS_FIXEDBMP|RBBS_NOGRIPPER))
		{
			TRACE0("Failed to create rebar\n");
			return -1;      // fail to create
		}

	//
	// Status bar initialisation
	if (!m_wndStatusBar.CreateStatusBar
				(this, indicators, sizeof(indicators)/sizeof(UINT)))
		{
			TRACE0("Failed to create status bar\n");
			return -1;      // fail to create
		}

	//
	// Set the status bar font size
	m_wndStatusBar.SetFontSize( 0, 16 );

	//
	// Set status bar pane styles
	m_wndStatusBar.SetMode( 1, XSB_BITMAP | DT_CENTER );
	m_wndStatusBar.SetMode( 2, XSB_BITMAP | DT_CENTER );

	m_wndStatusBar.SetWidth( 1, 20 );
	m_wndStatusBar.SetWidth( 2, 20 );

	m_wndStatusBar.SetBitmap( 1, IDB_ERROR_ON, -1 );
	m_wndStatusBar.SetBitmap( 2, IDB_WORKING_ON, -1 );

	//
	// Turn panes off
	m_wndStatusBar.EnablePane( 1, FALSE );
	m_wndStatusBar.EnablePane( 2, FALSE );

	//
	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle
		(m_wndToolBar.GetBarStyle() |	CBRS_TOOLTIPS | CBRS_FLYBY);

	AddSearchMenuItems();
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg( UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo )
{
	// let the view have first crack at the command
	if ( m_wndView.OnCmdMsg( nID, nCode, pExtra, pHandlerInfo ) )
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg( nID, nCode, pExtra, pHandlerInfo );
}

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT lpcs, CCreateContext* pContext ) 
{
//  BOOL ok = m_wndView.CreateSplitter( lpcs, pContext );
	BOOL ok = m_wndView.CreateStatic( this, 1, 2 );
	if ( ok == TRUE )
    {
      //
      // Create left hand notebook tabs
      m_wndView.CreateView
        ( 0, 0, RUNTIME_CLASS(PG_LHSTabWin), CSize(0, 0), pContext );

      //
      // Create right hand entry view.
      m_wndView.CreateView
        ( 0, 1, RUNTIME_CLASS(PG_RHSTabWin), CSize(256, 256), pContext );

      m_wndView.SetColumnInfo( 0, 256, 192 ) ;
			m_wndView.SetColumnInfo( 1, 256, 192 ) ;
			m_wndView.SetRowInfo( 0, 256, 192 ) ;

			//
			// Get pointers to tab controls
			CWnd *wnd = m_wndView.GetPane( 0, 0 );
			m_pLhsTabCtrl = static_cast<PG_LHSTabCtrl *>( wnd->GetDlgItem( 1024 ) );

			wnd = m_wndView.GetPane( 0, 1 );
			m_pRhsTabCtrl = static_cast<PG_RHSTabCtrl *>( wnd->GetDlgItem( 1024 ) );
    }

	return CFrameWnd::OnCreateClient(lpcs, pContext);
}

void CMainFrame::CreateTabPages()
{
	m_pLhsTabCtrl->CreateTabPages();
	m_pRhsTabCtrl->CreateTabPages();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::PostNcDestroy
void CMainFrame::PostNcDestroy() 
{
	CFrameWnd::PostNcDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::WaitMode
// Switch PC-Pages in and out of wait mode.
void CMainFrame::WaitMode( BOOL bOn )
{
	if ( bOn == m_bWait )
		return;

	//
	// Reset operation counts if we're 
	// switching out of wait mode
	if ( bOn == FALSE )
		SetOpCounts( -1, -1, -1 );

	//
	// Disable/enable working windows as appropriate
	CWnd *pWaitBtn = m_wndDlgBar.GetDlgItem( ID_FILE_ABORT );
	pWaitBtn->EnableWindow( bOn );

	m_pLhsTabCtrl->EnableWindow( !bOn );
	m_pRhsTabCtrl->EnableWindow( !bOn );

	//
	// Enable/disable waiting animation
	if ( bOn == TRUE )
		{
			SetTimer( 1, 100, NULL);
			m_nWaitFrameIdx = 0;
		}
	else 
		{
			KillTimer( 1 );
			SetWaitAnimFrame( -1 );
		}

	//
	// Set waiting flag
	m_bWait = bOn;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::OnSocketClose
// Socket close notification handler. This links the Winsock notification
// events to the Query engine.
LRESULT CMainFrame::OnSocketClose( WPARAM wParam, LPARAM lParam )
{
	extern CPCPages32App theApp;
	theApp.DS()->NotifySocketClose( static_cast<SOCKET>( wParam ) );
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::SetMessageText
// Set status bar message.
void CMainFrame::SetMessageText( LPCTSTR pStr )
{
	m_wndStatusBar.SetPaneText( 0, pStr );
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::FlashMessageText
// Flash the status bar.
void CMainFrame::FlashMessageText()
{
	m_wndStatusBar.Flash( 0 );
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::SetOpCounts
// Set operation counts in the "Wait" dialog bar.
void CMainFrame::SetOpCounts( int nInvoked, int nSucceeded, int nFailed )
{
	CString cntStr;

	//
	// Operations invoked
	CWnd *pEditWnd = m_wndDlgBar.GetDlgItem( IDC_WAIT_EDIT1 );
	if ( pEditWnd != NULL )
		{
			if ( nInvoked >= 0 )
				cntStr.Format( "%d", nInvoked );
			else
				cntStr = "";

			pEditWnd->SetWindowText( cntStr );
		}

	//
	// Operations succeeded
	pEditWnd = m_wndDlgBar.GetDlgItem( IDC_WAIT_EDIT2 );
	if ( pEditWnd != NULL )
		{
			if ( nInvoked >= 0 )
				cntStr.Format( "%d", nSucceeded );
			else
				cntStr = "";

			pEditWnd->SetWindowText( cntStr );
		}

	//
	// Operations failed
	pEditWnd = m_wndDlgBar.GetDlgItem( IDC_WAIT_EDIT3 );
	if ( pEditWnd != NULL )
		{
			if ( nInvoked >= 0 )
				cntStr.Format( "%d", nFailed );
			else
				cntStr = "";

			pEditWnd->SetWindowText( cntStr );
		}

}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::AddSearchMenuItem
// Add a search menu item that when selected will raise the identified
// search form tab page.
void CMainFrame::AddSearchMenuItem( CString &rName, int nTabID )
{
	CMenu *pMenu = GetMenu();

	CMenu *pSrchMenu = pMenu->GetSubMenu( 3 );
	pSrchMenu->AppendMenu( MF_STRING, ID_SRCHMENU_BASE+nTabID, rName );
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::AddSearchMenuItems
// Add all forms to the search menu
void CMainFrame::AddSearchMenuItems()
{
	extern CPCPages32App theApp;
	CStringList formList;

	QFormConfiguration *pFormConf = theApp.DS()->FormConfig();
	pFormConf->GetFormList( formList );

	int nIndex = 1;
	POSITION pos = formList.GetHeadPosition();
	while ( pos != NULL )
		{
			CString name = formList.GetNext( pos );
			AddSearchMenuItem( name, nIndex++ );
		}
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::OnSrchMenuItem
// Abort clicked by user.
void CMainFrame::OnSrchMenuItem( UINT nID )
{
	m_pLhsTabCtrl->SelectTab( nID - ID_SRCHMENU_BASE, TRUE );	
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::OnWaitAbort
// Abort clicked by user.
void CMainFrame::OnWaitAbort() 
{
	if ( m_bWait == FALSE )
		return;

	//
	// Abort operations
	extern CPCPages32App theApp;
	theApp.DS()->AbortAll();	

	//
	// Reset the user interface
	WaitMode( FALSE );
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::OnUpdateFileAbort
// Enable/disable the File->Abort menu item and the "Abort" dialog bar
// button as appropriate.
void CMainFrame::OnUpdateFileAbort( CCmdUI* pCmdUI )
{
	pCmdUI->Enable( m_bWait );
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::OnTimer
// The timer is used to control the "working" animation
void CMainFrame::OnTimer( UINT nIDEvent ) 
{
	if ( nIDEvent == 1 )
		{
			if ( m_nWaitFrameIdx++ == 8 )
				m_nWaitFrameIdx = 0;

			SetWaitAnimFrame( m_nWaitFrameIdx );
		}

	CFrameWnd::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::SetWaitAnimFrame
// Set the current frame in the busy animation
void CMainFrame::SetWaitAnimFrame( int nFrameID )
{
	CStatic *pStatic =
		reinterpret_cast<CStatic *>( m_wndAnimBar.GetDlgItem( IDC_ANIM_STATIC_BITMAP ) );

	HBITMAP hNew =
		( HBITMAP )
				LoadImage
					( AfxGetInstanceHandle(),
						MAKEINTRESOURCE( IDB_BITMAP1 + nFrameID ),
						IMAGE_BITMAP,
						0, 0,
						LR_LOADTRANSPARENT ) ;

	if ( hNew == NULL )
		{
			//
			// Couldn't load the bitmap!
#ifdef _DEBUG
			TRACE0( "Failed to load bitmap for working animation.\n" );
#endif
			return;
		}

	HBITMAP hOld = pStatic->SetBitmap( hNew );
	DeleteObject( hOld );
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame::OnSrchBrowse
// Display the browser
void CMainFrame::OnSrchBrowse() 
{
	m_pLhsTabCtrl->SelectTab( 0, TRUE );
}

void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	extern CPCPages32App theApp;
	if ( m_wndStatusBar.GetPaneAtPosition( point ) == 1 )
		{
			theApp.ShowErrors();
		}
	
	CFrameWnd::OnLButtonDblClk(nFlags, point);
}
